(use-translation _ "alterator-users")

(define (root?)
  (let ((name (global 'username)))
    (or (not name)
	(string=? name "root"))))

;case of subwindow in wizard
(on-next (and (change-passwd) (goto "/users")))
(on-prev (goto "/users"))

;case of main window in wizard
(on-apply (change-passwd))

(define (on-change-error reason)
  (if (string=? reason "passwords mismatch")
    (run-dialog '("/users/mismatch"))
    (run-dialog '("/error")))
  (passwd1 text "")
  (passwd2 text "")
  #f)

(define (change-passwd)
  (woo-catch
    (lambda()
      (woo-write (string-append "/users/" (or (global 'username) "root"))
		 'type 'local
		 'passwd1 (passwd1 text)
		 'passwd2 (passwd2 text))
      (passwd1 text "")
      (passwd2 text "")
      #t)
    on-change-error))


((global 'disable-next))

(define (can-next)
  (next-button enabled (and (not-empty-string? (passwd1 text))
			    (not-empty-string? (passwd2 text)))))

(vbox sizepolicy 'fixed
      (label (string-append (_ "Enter new password for ")
			    (if (root?) (_ "system administrator") (global 'username)))
	     font "-*-*-bold-*-*--*-*-*-*-*-*-*-*")
      (hbox spacing 1 margin 2
	    (vbox
	      (label (_ "New password:") height 3)
	      (label (_ "New password (re-type):") height 3))
	    (vbox
	      (id 'passwd1 (edit ""
				 echo stars
				 focus #t
				 height 3
				 (relative-width 50 page)
				 (on-return (passwd2 focus #t))
				 (on-change (can-next))))
	      (id 'passwd2 (edit ""
				 echo stars
				 height 3
				 (on-return (next-button focus #t))
				 (relative-width 50 page)
				 (on-change (can-next)))))))

